Option Strict Off
Option Explicit On
Imports System.Drawing

Friend Class Form1
    Inherits System.Windows.Forms.Form
    'AudioAnalyzer12 (AudioSA12v02a 04-10-2012)
    'Audio analyzer with the sound card by Onno Hoekstra pa2ohh

    'Graphics for VBnet
    Dim GRPHbufferA As BufferedGraphics         'Buffer for Manually Rendering Buffered Graphics to avoid flickering of the screen.
    Dim pen1 As New System.Drawing.Pen(Color.Black, 1)
    Dim pen2 As New System.Drawing.Pen(Color.Black, 1)
    Dim pengrid As New System.Drawing.Pen(Color.Black, 1)
    Dim point1 As System.Drawing.Point          'A general point1 used in graphic routines
    Dim point2 As System.Drawing.Point          'A general point2 used in graphic routines
    Dim intDivX As Integer                      'Pixels per division (width)
    Dim intWidthX As Integer                    'Width in pixels
    Dim intDivY As Integer                      'Pixels per division (height)
    Dim intHeightY As Integer                   'Height in pixels

    'Others
    Dim blnMEMdisplay As Boolean = False        'If True then display memory trace
    Dim blnOverload As Boolean = False          'If overload then True
    Dim blnRUNstatus As Boolean = False         'If False, then stopped
    Dim intMAXbins As Integer = 262144          'Maximum number of bins
    Dim intHALFMAXbins As Integer = 131072      'Half the maximum number of bins, used for traces
    Dim intNbins As Integer                     'Number of points in the DFT,
    Dim intFFTbins As Integer                   'Number of points in the FFT after Zero padding
    Dim intFFT2bins As Integer                  'Number of points in the FFT of memory trace 2 after Zero padding
    Dim REX(intMAXbins) As Double               'Real part array of input for FFT routine
    Dim IMX(intMAXbins) As Double               'Imaginary part of input for FFT routine
    Dim DISPLAYtrc(intHALFMAXbins) As Double    'Trace to display
    Dim MEMORYtrc(intHALFMAXbins) As Double     'Memory trace to display / calculate
    Dim TRACE1_X(intHALFMAXbins) As Double      'Trace1 to display
    Dim TRACE1_Y(intHALFMAXbins) As Double      'Trace1 to display
    Dim TRACE2_X(intHALFMAXbins) As Double      'Trace2 to display
    Dim TRACE2_Y(intHALFMAXbins) As Double      'Trace2 to display
    Dim sngReflvl As Single                     'Reference level of the top of the grid
    Dim sngOffset As Single                     'Offset for Trace2
    Dim sngdBdiv As Single                      'dB per division of the grid
    Dim intSkipTime As Integer                  'Skip the first distorted part of the audio buffer
    Dim intFFTwindow As Integer                 'The FFT window
    Dim intZeroPadding As Integer = 0           'ZeroPadding power of 2

    Public intSampleRate As Integer             'The sample rate of the audio stream
    Public blnDEMO As Boolean = False           'Active for testing purposes
    Public blnGRPHbufferA As Boolean = False    'True if the Buffer is available for Graphics

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initializing various variables when the Form1 is loaded (is the start of the program) 
        sngReflvl = scrReflvl.Value
        sngdBdiv = scrdBdiv.Value

        intSampleRate = Val(cboSRate.Text)

        txtFMin.Text = "0"                  'Initialize Fmin to 0 Hz
        txtFMax.Text = "20000"              'Initialize Fmax to 20000 Hz
        scrAVG.Value = 10                   'Initialize Averaging to 10

        cboBins.Items.Clear()               'Clear and add the FFT array sample selections to the combo box
        cboBins.Items.Add("65536")
        cboBins.Items.Add("32768")
        cboBins.Items.Add("16384")
        cboBins.Items.Add("8192")
        cboBins.Items.Add("4096")
        cboBins.Items.Add("2048")
        cboBins.Items.Add("1024")
        cboBins.Items.Add("512")
        cboBins.Items.Add("256")
        cboBins.Items.Add("128")
        cboBins.Items.Add("64")

        cboSRate.Items.Clear()              'Clear and add the samplerate selections to the combo box
        cboSRate.Items.Add("192000")
        cboSRate.Items.Add("96000")
        cboSRate.Items.Add("48000")
        cboSRate.Items.Add("44100")
        cboSRate.Items.Add("22050")
        cboSRate.Items.Add("11025")
        cboSRate.Items.Add("5512")
        cboSRate.Items.Add("2256")

        intNbins = Val(cboBins.Text)        'Number of samples must be  2^k  where k = integer > 1
        intFFTbins = intNbins               'Just for initialisation to prevent writing out of index if no data available at start
        intFFT2bins = intFFTbins            'Just for initialisation to prevent writing out of index if no data available at start
        intZeroPadding = 0                  'Just for initialisation to prevent writing out of index if no data available at start
        BUFFER_SIZE = intNbins * 2          'Must be at least 2 * max number of bins

    End Sub

    Private Sub Form1_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim Cancel As Boolean = eventArgs.Cancel
        Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason

        blnRUNstatus = False    'Stop scanning

        If (fRecording) Then    'Not necessary, but leave it here
            StopInput()
        End If

        eventArgs.Cancel = Cancel
    End Sub

    Private Sub CmdStart_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStart.Click
        Dim sngDEMOfreq1 As Single
        Dim sngDEMOlvl1 As Single
        Dim sngDEMOfreq2 As Single
        Dim sngDEMOlvl2 As Single
        Dim sngDEMOnoise As Single

        frmSample.Enabled = False
        blnRUNstatus = True
        cmdStart.Enabled = False
        CmdStop.Enabled = True
        CmdStop.Focus()

        If optFFTwindow5.Checked = True Then 'If FFTwindow 5 is selected during start, then activate DEMO mode
            blnDEMO = True
        Else
            blnDEMO = False
        End If

        If blnDEMO = True Then              'Ask input for 1st DEMO signal
            Try
                sngDEMOfreq1 = InputBox("DEMO frequency1", "DEMO FREQUENCY1")
                sngDEMOlvl1 = InputBox("DEMO level1 (0 - 100%)", "DEMO LEVEL1")
            Catch ex As Exception
                sngDEMOfreq1 = 0            'If Cancel or wrong input, make signal2 = 0
                sngDEMOlvl1 = 0             'If Cancel or wrong input, make signal2 = 0
                blnDEMO = False             'If first signal = 0 then disable DEMO mode
            End Try
        End If

        If blnDEMO = True Then              'Ask input for 2nd DEMO signal
            Try
                sngDEMOfreq2 = InputBox("DEMO frequency2", "DEMO FREQUENCY2")
                sngDEMOlvl2 = InputBox("DEMO level2 (0 - 100%)", "DEMO LEVEL2")
            Catch ex As Exception
                sngDEMOfreq2 = 0            'If Cancel or wrong input, make signal2 = 0
                sngDEMOlvl2 = 0             'If Cancel or wrong input, make signal2 = 0
            End Try
        End If

        If blnDEMO = True Then              'Ask input for noise level
            Try
                sngDEMOnoise = InputBox("DEMO noise level (0 - 100%)", "DEMO NOISE LEVEL")
            Catch ex As Exception
                sngDEMOnoise = 0            'If Cancel or wrong input, make noise signal = 0
            End Try
        End If

        Do While blnRUNstatus = True

            If optFFTwindow1.Checked = True Then
                intFFTwindow = 5
                intZeroPadding = 1
            End If

            If optFFTwindow2.Checked = True Then
                intFFTwindow = 6
                intZeroPadding = 1
            End If

            If optFFTwindow3.Checked = True Then
                intFFTwindow = 1
                intZeroPadding = 1
            End If

            If optFFTwindow4.Checked = True Then
                intFFTwindow = 0
                intZeroPadding = 2
            End If

            If optFFTwindow5.Checked = True Then
                intFFTwindow = 0
                intZeroPadding = 0
            End If

            'Skip the first distorted part of the audio buffer
            'when the sound card and audio stream is activated!
            'Default 100ms, can perhaps be reduced.
            intSkipTime = scrUpdateTime.Value * 20          'Conversion to ms, 20 ms per step
            SkipAudioSamples = Int(intSampleRate / 1000 * intSkipTime)

            BUFFER_SIZE = (SkipAudioSamples + intNbins) * 2 'Must be at least 2 * (max number of bins + SkipAudioSamples)

            'If DEMO mode, then use the DEMO frequencies and levels
            If blnDEMO = True Then
                DEMOAudio(sngDEMOfreq1, sngDEMOlvl1, sngDEMOfreq2, sngDEMOlvl2, sngDEMOnoise)
            Else
                Call StartInput()                   'Start new reading etc.
                Call GetAudio()                     'Get the audio
                Call StopInput()                    'Stop input
            End If

            Call DrawSpectrum()                     'Draw the spectrum

            System.Windows.Forms.Application.DoEvents() 'Update events

        Loop

    End Sub

    Private Sub CmdStop_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CmdStop.Click
        'Click stop button
        frmSample.Enabled = True
        blnRUNstatus = False
        cmdStart.Enabled = True
        CmdStop.Enabled = False
        cmdStart.Focus()

    End Sub

    Private Sub cmdDisplaytrace_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdDisplaytrace.Click
        'Click display memory trace 2 button
        If blnMEMdisplay = False Then
            blnMEMdisplay = True
            cmdDisplaytrace.Text = "Blank"
        Else
            blnMEMdisplay = False
            cmdDisplaytrace.Text = "Display"
        End If

    End Sub

    Private Sub cmdStore_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStore.Click
        'Click store trace1 to memory trace 2 button
        Dim intBin As Integer
        Dim intN As Integer

        For intBin = 0 To intFFTbins / 2
            MEMORYtrc(intBin) = DISPLAYtrc(intBin)
        Next

        For intN = intFFTbins / 2 To intHALFMAXbins
            MEMORYtrc(intN) = DISPLAYtrc(intFFTbins / 2)
        Next

        intFFT2bins = intFFTbins                        'Store the number of FFT bins of the trace, can be changed due to different Zero padding

    End Sub

    Private Sub cboBins_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboBins.SelectedIndexChanged
        'New value of FFTbins is selected
        intNbins = Val(cboBins.Text)        'Number of FFTbins must be  2^k  where k = integer > 1
    End Sub

    Private Sub cboSRate_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboSRate.SelectedIndexChanged
        'New value of Sample rate of the audio stream is selected
        intSampleRate = Val(cboSRate.Text)
    End Sub

    Private Sub chkBW_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkBW.CheckStateChanged
        'New state of the Black and White checkbox
        Call MakeDisplayTrace()
        Call DisplayTraces()
    End Sub

    Private Sub chkSmall_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkSmall.CheckStateChanged
        'New state of the Small screen checkbox
        Call MakeDisplayTrace()
        Call DisplayTraces()
    End Sub

    Private Sub chkGrid_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkGrid.CheckedChanged
        'New state of the Grid checkbox (gray or white grid)
        Call MakeDisplayTrace()
        Call DisplayTraces()
    End Sub

    Private Sub scrAVG_Change(ByVal newScrollValue As Integer)
        'New value of the Average scrollbar
        lblAV.Text = "Av " & LTrim(Str(newScrollValue))
    End Sub

    Private Sub scrReflvl_Change(ByVal newScrollValue As Integer)
        'New value of the Reference level scrollbar
        sngReflvl = newScrollValue
        lblReflvl.Text = "Ref: " & sngReflvl & " dB"
        Call MakeDisplayTrace()
        Call DisplayTraces()
    End Sub

    Private Sub scrT2Offset_Change(ByVal newScrollValue As Integer)
        'New value of the Memory trace 2 offset scrollbar
        sngOffset = newScrollValue
        lblT2Offset.Text = sngOffset & " dB"
        Call MakeDisplayTrace()
        Call DisplayTraces()
    End Sub

    Private Sub scrdBdiv_Change(ByVal newScrollValue As Integer)
        'New value of the dB per divisions scrollbar
        sngdBdiv = newScrollValue
        lbldBdiv.Text = sngdBdiv & " dB/div"
        Call MakeDisplayTrace()
        Call DisplayTraces()
    End Sub

    Private Sub scrUpdateTime_Change(ByVal newScrollValue As Integer)
        'New value of the Time scrollbar (the first skipped part of the audio buffer that is perhaps distorted)
        lblTime.Text = "T= " & Str(20 * newScrollValue) & " ms"
    End Sub

    Private Sub scrAVG_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles scrAVG.Scroll
        'Activated by Average scrollbar change
        Select Case eventArgs.Type
            Case System.Windows.Forms.ScrollEventType.EndScroll
                scrAVG_Change(eventArgs.NewValue)               'Call this routine
        End Select
    End Sub

    Private Sub scrReflvl_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles scrReflvl.Scroll
        'Activated by Reference level scrollbar change
        Select Case eventArgs.Type
            Case System.Windows.Forms.ScrollEventType.EndScroll
                scrReflvl_Change(eventArgs.NewValue)            'Call this routine
        End Select
    End Sub

    Private Sub scrT2Offset_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles scrT2Offset.Scroll
        'Activated by Memory trace 2 offset scrollbar change
        Select Case eventArgs.Type
            Case System.Windows.Forms.ScrollEventType.EndScroll
                scrT2Offset_Change(eventArgs.NewValue)          'Call this routine
        End Select
    End Sub

    Private Sub scrdBdiv_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles scrdBdiv.Scroll
        'Activated by dB per divisions scrollbar change
        Select Case eventArgs.Type
            Case System.Windows.Forms.ScrollEventType.EndScroll
                scrdBdiv_Change(eventArgs.NewValue)             'Call this routine
        End Select
    End Sub

    Private Sub scrUpdateTime_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.ScrollEventArgs) Handles scrUpdateTime.Scroll
        'Activated by Time scrollbar change(the first skipped part of the audio buffer that is perhaps distorted)
        Select Case eventArgs.Type
            Case System.Windows.Forms.ScrollEventType.EndScroll
                scrUpdateTime_Change(eventArgs.NewValue)        'Call this routine
        End Select
    End Sub

    Sub GetAudio()
        'Read the audio samples from the recorded and stored audio in memory 
        Dim intSample As Integer
        Dim dblSampleValue As Double
        Dim v As Double
        Dim w As Double
        Dim n As Double

        blnOverload = False

        For intSample = 0 To intNbins - 1
            Call GetMono16Sample((intSample + SkipAudioSamples), dblSampleValue) 'Get one sample in dblSampleValue

            v = dblSampleValue      'Use v just to keep the code general, short and readable
            n = intSample           'Use n just to keep the code general, short and readable

            If dblSampleValue < -0.5 Or dblSampleValue > 0.5 Then   'Overload of the input, clipping signal
                blnOverload = True
            End If

            ' Cosine window function
            ' medium-dynamic range B=1.24
            If intFFTwindow = 1 Then
                w = Math.Sin(Math.PI * n / (intNbins - 1))
                v = w * v * 1.571
            End If

            ' Triangular non-zero endpoints
            ' medium-dynamic range B=1.33
            If intFFTwindow = 2 Then
                w = (2.0 / intNbins) * ((intNbins / 2.0) - Math.Abs(n - (intNbins - 1) / 2.0))
                v = w * v * 2.0
            End If

            ' Hann window function
            ' medium-dynamic range B=1.5
            If intFFTwindow = 3 Then
                w = 0.5 - 0.5 * Math.Cos(2 * Math.PI * n / (intNbins - 1))
                v = w * v * 2.0
            End If

            ' Blackman window, continuous first derivate function
            ' medium-dynamic range B=1.73
            If intFFTwindow = 4 Then
                w = 0.42 - 0.5 * Math.Cos(2 * Math.PI * n / (intNbins - 1)) + 0.08 * Math.Cos(4 * Math.PI * n / (intNbins - 1))
                v = w * v * 2.381
            End If

            ' Nuttall window, continuous first derivate function
            ' high-dynamic range B=2.02
            If intFFTwindow = 5 Then
                w = 0.355768 - 0.487396 * Math.Cos(2 * Math.PI * n / (intNbins - 1)) + 0.144232 * Math.Cos(4 * Math.PI * n / (intNbins - 1)) - 0.012604 * Math.Cos(6 * Math.PI * n / (intNbins - 1))
                v = w * v * 2.811
            End If

            ' Flat top window 
            ' medium-dynamic range, extra wide bandwidth B=3.77
            If intFFTwindow = 6 Then
                w = 1.0 - 1.93 * Math.Cos(2 * Math.PI * n / (intNbins - 1)) + 1.29 * Math.Cos(4 * Math.PI * n / (intNbins - 1)) - 0.388 * Math.Cos(6 * Math.PI * n / (intNbins - 1)) + 0.032 * Math.Cos(8 * Math.PI * n / (intNbins - 1))
                v = w * v * 1.0
            End If

            ' m = m + w / intNbins                 For calculation of correction factor

            REX(intSample) = v      'The windowed value of dblSampleValue
            IMX(intSample) = 0      'Imaginary part is 0

        Next
        'Add extra zeros for Zero Padding so that extra FFT points are inserted
        intFFTbins = intNbins * (2 ^ intZeroPadding)
        For intSample = intNbins To (intFFTbins - 1)
            REX(intSample) = 0
            IMX(intSample) = 0
        Next

        Call FFT(CInt(intFFTbins), REX, IMX)    'Call the FFT calculation routine

    End Sub

    Sub DEMOAudio(ByVal sngDEMOfreq1 As Single, ByVal sngDEMOlevel1 As Single, ByVal sngDEMOfreq2 As Single, ByVal sngDEMOlevel2 As Single, ByVal sngDEMOnoise As Single)
        'Calculate the value of the audio samples in DEMO mode
        Dim intSample As Integer
        Dim dblSampleValue As Double
        Dim dblDELTAphase1 As Double
        Dim dblDELTAphase2 As Double
        Dim v As Double
        Dim w As Double
        Dim n As Double

        dblDELTAphase1 = Math.PI * 2 / (CDbl(intSampleRate) / CDbl(sngDEMOfreq1))   'Delta phase per sample for DEMO freq1
        dblDELTAphase2 = Math.PI * 2 / (CDbl(intSampleRate) / CDbl(sngDEMOfreq2))   'Delta phase per sample for DEMO freq2

        blnOverload = False

        For intSample = 0 To intNbins - 1

            dblSampleValue = Math.Sin(CDbl(intSample) * dblDELTAphase1) * CDbl(sngDEMOlevel1)                   'Signal1
            dblSampleValue = dblSampleValue + Math.Sin(CDbl(intSample) * dblDELTAphase2) * CDbl(sngDEMOlevel2)  'Signal2
            dblSampleValue = dblSampleValue + CDbl(2 * (Rnd() - 0.5) * sngDEMOnoise)                            'Noise

            'Correct for in +0.5 to -0.5 maximum range (100% = 0.5)
            dblSampleValue = 0.005 * dblSampleValue

            v = dblSampleValue      'Use v just to keep the code general, short and readable
            n = intSample           'Use n just to keep the code general, short and readable

            If dblSampleValue < -0.5 Or dblSampleValue > 0.5 Then   'Overload of the input, clipping signal
                blnOverload = True
            End If

            ' Cosine window function
            ' medium-dynamic range B=1.24
            If intFFTwindow = 1 Then
                w = Math.Sin(Math.PI * n / (intNbins - 1))
                v = w * v * 1.571
            End If

            ' Triangular non-zero endpoints
            ' medium-dynamic range B=1.33
            If intFFTwindow = 2 Then
                w = (2.0 / intNbins) * ((intNbins / 2.0) - Math.Abs(n - (intNbins - 1) / 2.0))
                v = w * v * 2.0
            End If

            ' Hann window function
            ' medium-dynamic range B=1.5
            If intFFTwindow = 3 Then
                w = 0.5 - 0.5 * Math.Cos(2 * Math.PI * n / (intNbins - 1))
                v = w * v * 2.0
            End If

            ' Blackman window, continuous first derivate function
            ' medium-dynamic range B=1.73
            If intFFTwindow = 4 Then
                w = 0.42 - 0.5 * Math.Cos(2 * Math.PI * n / (intNbins - 1)) + 0.08 * Math.Cos(4 * Math.PI * n / (intNbins - 1))
                v = w * v * 2.381
            End If

            ' Nuttall window, continuous first derivate function
            ' high-dynamic range B=2.02
            If intFFTwindow = 5 Then
                w = 0.355768 - 0.487396 * Math.Cos(2 * Math.PI * n / (intNbins - 1)) + 0.144232 * Math.Cos(4 * Math.PI * n / (intNbins - 1)) - 0.012604 * Math.Cos(6 * Math.PI * n / (intNbins - 1))
                v = w * v * 2.811
            End If

            ' Flat top window 
            ' medium-dynamic range, extra wide bandwidth B=3.77
            If intFFTwindow = 6 Then
                w = 1.0 - 1.93 * Math.Cos(2 * Math.PI * n / (intNbins - 1)) + 1.29 * Math.Cos(4 * Math.PI * n / (intNbins - 1)) - 0.388 * Math.Cos(6 * Math.PI * n / (intNbins - 1)) + 0.032 * Math.Cos(8 * Math.PI * n / (intNbins - 1))
                v = w * v * 1.0
            End If

            ' m = m + w / intNbins                 For calculation of correction factor

            REX(intSample) = v      'The windowed value of dblSampleValue
            IMX(intSample) = 0      'Imaginary part is 0

        Next

        'Add extra zeros for Zero Padding so that extra FFT points are inserted
        intFFTbins = intNbins * (2 ^ intZeroPadding)
        For intSample = intNbins To (intFFTbins - 1)
            REX(intSample) = 0
            IMX(intSample) = 0
        Next

        Call FFT(CInt(intFFTbins), REX, IMX)    'Call the FFT calculation routine

    End Sub

    Sub DrawSpectrum() 'The main routine for drawing the spectrum lines on the screen. This routine does call the others
        Call MakeDataTraces()                   'Convert to dB's and Normal, Maximum hold or Average
        Call MakeDisplayTrace()                 'Conversion to pixels
        Call DisplayTraces()                    'Display the grid and traces

    End Sub

    Sub MakeDataTraces()    'Convert to dB's and Normal, Maximum hold or Average trace
        Dim intBin As Integer
        Dim dblX As Double

        'dblCorrection = (2 ^ intZeroPadding) / intFFTbins is identical to 1 / intNbins

        For intBin = 0 To intFFTbins / 2

            dblX = System.Math.Sqrt(REX(intBin) * REX(intBin) + IMX(intBin) * IMX(intBin))
            dblX = 10 * dblX / intNbins         'Correction for changing FFT array length and 10x for in screen range
            dblX = 20 * System.Math.Log(dblX + 0.0000001) / System.Math.Log(10) 'Convert to dB's add 0.0000001 to avoid Log(0)

            If optNormal.Checked = True Then
                DISPLAYtrc(intBin) = dblX
            End If

            If optMaxhold.Checked = True And dblX > DISPLAYtrc(intBin) Then
                DISPLAYtrc(intBin) = dblX
            End If

            If optAverage.Checked = True Then
                DISPLAYtrc(intBin) = DISPLAYtrc(intBin) + (dblX - DISPLAYtrc(intBin)) / scrAVG.Value
            End If

        Next intBin
    End Sub

    Private Sub MakeDisplayTrace() 'The main routine that calls the two others for T1 and T2
        Call MakeDisplayTrace1(intFFTbins / 2)
        Call MakeDisplayTrace2(intFFT2bins / 2)

    End Sub

    Private Sub MakeDisplayTrace1(ByRef intLength As Integer)    'Conversion to pixels trace 1
        Dim intBin As Integer
        Dim intTraceCount As Integer
        Dim sngFreqMin, sngFreqMax As Single
        Dim sngFreq As Single
        Dim dblX As Double
        Dim dblY As Double

        Call SetGridSizes()

        sngFreqMin = Val(txtFMin.Text)
        sngFreqMax = Val(txtFMax.Text)

        If sngFreqMax <= sngFreqMin Then Exit Sub

        intTraceCount = 0

        For intBin = 0 To intLength
            dblY = DISPLAYtrc(intBin)
            dblY = sngReflvl - dblY
            dblY = intDivY * (dblY / sngdBdiv)      'Convert to pixels per division

            If dblY < 0 Then dblY = 0
            If dblY > intHeightY Then dblY = intHeightY

            dblY = dblY + intDivY / 2               'Add margin
            TRACE1_Y(intTraceCount) = dblY          'Store to the Trace array Y values

            sngFreq = CSng(intBin) / intFFTbins * intSampleRate 'The frequency of the sample

            If sngFreq < sngFreqMin Then
                dblX = 0                            'Left screen postion
            End If

            If sngFreq >= sngFreqMin And sngFreq <= sngFreqMax Then
                dblX = intWidthX * (sngFreq - sngFreqMin) / (sngFreqMax - sngFreqMin)
                dblX = dblX + intDivX / 2           'Add margin

                TRACE1_X(intTraceCount) = dblX      'Frequency X value
                TRACE1_X(intTraceCount + 1) = 9999  'End of array

                intTraceCount = intTraceCount + 1
            End If

            If sngFreq > sngFreqMax Then Exit For 'Finish

        Next intBin

    End Sub

    Private Sub MakeDisplayTrace2(ByRef intLength As Integer)    'Conversion to pixels trace 2
        Dim intBin As Integer
        Dim intTraceCount As Integer
        Dim sngFreqMin, sngFreqMax As Single
        Dim sngFreq As Single
        Dim dblX As Double
        Dim dblY As Double

        If blnMEMdisplay = False Then
            Exit Sub
        End If

        Call SetGridSizes()

        sngFreqMin = Val(txtFMin.Text)
        sngFreqMax = Val(txtFMax.Text)

        If sngFreqMax <= sngFreqMin Then Exit Sub

        intTraceCount = 0

        For intBin = 0 To intLength
            dblY = MEMORYtrc(intBin)
            dblY = sngReflvl - dblY
            dblY = dblY + scrT2Offset.Value     'Add the Trace 2 offset
            dblY = intDivY * (dblY / sngdBdiv)  'Convert to pixels per division

            If dblY < 0 Then dblY = 0
            If dblY > intHeightY Then dblY = intHeightY

            dblY = dblY + intDivY / 2           'Add margin

            TRACE2_Y(intTraceCount) = dblY      'Store to the Trace array Y values

            sngFreq = CSng(intBin) / intFFT2bins * intSampleRate 'The frequency of the sample

            If sngFreq < sngFreqMin Then
                dblX = 0                            'Left screen postion
            End If

            If sngFreq >= sngFreqMin And sngFreq <= sngFreqMax Then
                dblX = intWidthX * (sngFreq - sngFreqMin) / (sngFreqMax - sngFreqMin)
                dblX = dblX + intDivX / 2           'Add margin

                TRACE2_X(intTraceCount) = dblX      'Frequency X value
                TRACE2_X(intTraceCount + 1) = 9999  'End of array

                intTraceCount = intTraceCount + 1
            End If

            If sngFreq > sngFreqMax Then Exit For 'Finish

        Next intBin


    End Sub

    Private Sub MakeGrid()      'Write the grid to the picture box
        Dim intN As Integer
        Dim currentContext As BufferedGraphicsContext

        If chkOverWrite.CheckState = 1 And blnGRPHbufferA = True Then
            Exit Sub
        End If

        Call SetPens()
        Call SetGridSizes()

        'Manually Rendering Buffered Graphics to avoid flickering of the screen.
        'Open the (empty) graphic buffer and refer it to the size of the PictureBox!
        'In this buffer, the drawing is done.
        currentContext = BufferedGraphicsManager.Current
        GRPHbufferA = currentContext.Allocate(PictureBox1.CreateGraphics, _PictureBox1.DisplayRectangle)
        blnGRPHbufferA = True                           'The graphic buffer has been initialized

        'Draw grid vertical lines
        For intN = 0 To 10
            point1.X = intDivX / 2 + intN * intDivX
            point2.X = point1.X

            If intN <> 5 Then                           'Normal lines
                point1.Y = intDivY / 2
                point2.Y = point1.Y + intHeightY
            Else                                        'Extra long lines
                point1.Y = intDivY / 2 - 5
                point2.Y = point1.Y + intHeightY + 10
            End If
            GRPHbufferA.Graphics.DrawLine(pengrid, point1, point2)
        Next

        'Draw grid horizontal lines
        For intN = 0 To 10
            point1.Y = intDivY / 2 + intN * intDivY
            point2.Y = point1.Y

            If intN <> 5 Then                           'Normal lines
                point1.X = intDivX / 2
                point2.X = point1.X + intWidthX
            Else                                        'Extra long lines
                point1.X = intDivX / 2 - 5
                point2.X = point1.X + intWidthX + 10
            End If
            GRPHbufferA.Graphics.DrawLine(pengrid, point1, point2)
        Next

        'GRPHbufferA.Render(PictureBox1.CreateGraphics)

    End Sub

    Private Sub DisplayTraces()                     'Display the traces to the Graphic Buffer first to avoid Flicker       
        Dim intN As Integer
        Dim currentContext As BufferedGraphicsContext

        Call SetPens()

        currentContext = BufferedGraphicsManager.Current
        'GRPHbufferA = currentContext.Allocate(PictureBox1.CreateGraphics, _PictureBox1.DisplayRectangle) 'If it has to be cleared

        MakeGrid()

        'First memory trace 2 then the normal trace1
        If blnMEMdisplay = True Then
            For intN = 1 To intMAXbins
                If TRACE2_X(intN) = 9999 Then       'Frequency higher than Screen range
                    Exit For
                End If

                If TRACE2_X(intN - 1) >= 0 Then     'Frequency in Screen range
                    point1.X = TRACE2_X(intN - 1)
                    point1.Y = TRACE2_Y(intN - 1)
                    point2.X = TRACE2_X(intN)
                    point2.Y = TRACE2_Y(intN)
                    GRPHbufferA.Graphics.DrawLine(pen2, point1, point2) 'Draw to the Graphic buffer
                End If
            Next intN
        End If

        'Memory trace 1
        For intN = 1 To intMAXbins
            If TRACE1_X(intN) = 9999 Then           'Frequency higher than Screen range
                Exit For
            End If

            If TRACE1_X(intN - 1) >= 0 Then         'Frequency in Screen range
                point1.X = TRACE1_X(intN - 1)
                point1.Y = TRACE1_Y(intN - 1)
                point2.X = TRACE1_X(intN)
                point2.Y = TRACE1_Y(intN)
                GRPHbufferA.Graphics.DrawLine(pen1, point1, point2) 'Draw to the Graphic buffer
            End If
        Next intN

        GRPHbufferA.Render(PictureBox1.CreateGraphics)  'Fill the PictureBox1 with the contents of the Graphic buffer

        If chkOverWrite.CheckState = 0 Then
            GRPHbufferA.Dispose()                   'Dispose the memory of the Graphic Buffer (otherwise much increasing memory in use)
            blnGRPHbufferA = False                  'The buffer is not initialized for Graphics anymore
        End If

    End Sub

    Private Sub SetPens()    'Set pen colors
        If chkBW.Checked = True Then    'Black & White screen
            pen1.Color = Color.White
            pen2.Color = Color.White
            pengrid.Color = Color.Gray
        Else                            'Color screen
            pen1.Color = Color.Lime
            pen2.Color = Color.Orange
            pengrid.Color = Color.Gray
        End If

        If blnOverload = True Then      'If overload (clipping input signal) then a red trace
            pen1.Color = Color.Red
        End If

        If chkGrid.Checked = True Then  'If checkbox checked, than white grid instead of gray grid
            pengrid.Color = Color.White
        End If

    End Sub

    Private Sub SetGridSizes()  'Get the grid sizes from the actual size of the picture box
        intDivX = Int(PictureBox1.Width / 11)               'Ten divisions and two half divisions as margin around the grid
        intDivY = Int(PictureBox1.Height / 11)

        If chkSmall.CheckState = CheckState.Checked Then    'Small screen is half of the normal screen
            intDivX = intDivX / 2
            intDivY = intDivY / 2
        End If

        intWidthX = intDivX * 10                            'The width of the grid is 10 divisions
        intHeightY = intDivY * 10                           'The height of the grid is 10 divisions

    End Sub

    Private Sub PrintMessage(ByVal strText As String)   'Only used for debugging purposes, textbox is normally invisible
        strText = Chr(13) & Chr(10) & strText
        txtMessage.Text = txtMessage.Text & strText
        If Len(txtMessage.Text) > 3000 Then txtMessage.Text = Mid(txtMessage.Text, 1, 29000)
    End Sub

End Class